// SQLGenDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SQLGen.h"
#include "SQLGenDlg.h"
#include "global.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSQLGenDlg dialog

CSQLGenDlg::CSQLGenDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSQLGenDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSQLGenDlg)
	m_fileName = _T("h:\\programs\\videompeg\\metadata\\");
	m_frameFeatures = TRUE;
	m_shotFeatures = TRUE;
	m_fileSize = 1000;
	m_serverPath = _T("/u/u18/vdbms/mpeg_samples/MetaData/SQL/");
	m_mpegFeatures = TRUE;
	m_otherFeatures = TRUE;
	m_insertForKeyFrames = TRUE;
	m_insertForVideoShot = TRUE;
	m_clientPath = _T("h:\\Programs\\VideoMPEG\\metadata\\");
	m_outputPath = _T("h:\\programs\\videompeg\\metadata\\");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSQLGenDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSQLGenDlg)
	DDX_Text(pDX, IDC_FILENAME, m_fileName);
	DDX_Check(pDX, IDC_FRAMEFEATURES, m_frameFeatures);
	DDX_Check(pDX, IDC_SHOTFEATURES, m_shotFeatures);
	DDX_Text(pDX, IDC_FILE_SIZE, m_fileSize);
	DDX_Text(pDX, IDC_SERVERPATH, m_serverPath);
	DDX_Check(pDX, IDC_MPEG7FEATURES, m_mpegFeatures);
	DDX_Check(pDX, IDC_OTHERFEATURES, m_otherFeatures);
	DDX_Check(pDX, IDC_INSERTKEYFRAMES, m_insertForKeyFrames);
	DDX_Check(pDX, IDC_INSERTVIDEOSHOTS, m_insertForVideoShot);
	DDX_Text(pDX, IDC_CLIENTPATH, m_clientPath);
	DDX_Text(pDX, IDC_OUTPUTPATH, m_outputPath);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSQLGenDlg, CDialog)
	//{{AFX_MSG_MAP(CSQLGenDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSQLGenDlg message handlers

BOOL CSQLGenDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSQLGenDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSQLGenDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSQLGenDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
//--------------------------------------------------------------------
void CSQLGenDlg::OnOK() 
{
	// TODO: Add extra validation here
	UpdateData(TRUE);
	
	if (!m_mpegFeatures && !m_otherFeatures && !m_insertForKeyFrames && !m_insertForVideoShot)
	{
		AfxMessageBox("Should select at least one type of features to generate or to genearte Insert Statements for VideoShot or KeyFrames");
		return;
	}

	if (m_frameFeatures)
	{
		if (m_mpegFeatures)
			createMPEGFFeaturesDataFiles(m_fileName,m_outputPath,m_fileSize, m_serverPath);
		if (m_otherFeatures)
			createFrameFeaturesDataFiles(m_fileName,m_outputPath,m_fileSize, m_serverPath);
	}	
	if (m_shotFeatures)
	{
		if (m_mpegFeatures)
			createMPEGFeaturesDataFiles(m_fileName,m_outputPath,m_fileSize, m_serverPath);
		if (m_otherFeatures)
			createFeaturesDataFiles(m_fileName,m_outputPath,m_fileSize, m_serverPath);
	}

	if (m_insertForKeyFrames)
		createSQLForKeyFrames(m_fileName, m_outputPath,m_clientPath, m_serverPath);

	if (m_insertForVideoShot)
		createSQLForVideoShot(m_fileName, m_outputPath,m_clientPath, m_serverPath);

	AfxMessageBox("DONE.. .dat and .sql files generated for " + m_fileName);

	CDialog::OnOK();
}
//------------------------------------------------------------------------

void CSQLGenDlg::createFrameFeaturesDataFiles(CString fileName, CString outputPath, int fileSize, CString serverPath)
{
	/*open one file of load sql statements. Will contain the load commands for 
	the FrameFeatures and MPEGFFeatures tables */
	// open the features input files
	CFile *featuresFiles[NOOFFILES], *dataFile, *loadFile;
	CArchive *featuresAr[NOOFFILES];

	int i;
	for (i=0; i<NOOFFILES;i++)
		featuresFiles[i] = 0;

	featuresFiles[CHFILE] = new CFile(fileName + "CHF.txt",CFile::modeRead);
	featuresFiles[CMFILE] = new CFile(fileName + "CMF.txt",CFile::modeRead);
	featuresFiles[CLFILE] = new CFile(fileName + "CLF.txt",CFile::modeRead);
	featuresFiles[MHFILE] = new CFile(fileName + "MHF.txt",CFile::modeRead);
	featuresFiles[TTFILE] = new CFile(fileName + "TTF.txt",CFile::modeRead);
	featuresFiles[TEFILE] = new CFile(fileName + "TEF.txt",CFile::modeRead);
	featuresFiles[CHHSVFILE] = new CFile(fileName + "CHHSVF.txt",CFile::modeRead);

	for (i=0; i < NOOFFILES; i++)
		if (featuresFiles[i])
			featuresAr[i] = new CArchive(featuresFiles[i],CArchive::load);

	int fileNo, recordNo, pos;
	CString l, f1,f2, f3, outputFileName,ext,videoId,shotId,frameId;
	char s[10000], temp[20];;

	fileNo = recordNo = 0;
	getFileNameParts(fileName, outputFileName, ext);
	// open the file contains the FrameFeatures data and write the load command in the load file
	loadFile = new CFile(outputPath + outputFileName + "FLoad.sql",CFile::modeWrite | CFile::modeCreate);
	l = outputPath + outputFileName + "F0.dat";
	dataFile = new CFile(l,CFile::modeWrite | CFile::modeCreate);
	l = serverPath + outputFileName + "F0.dat";
	sprintf(s,"LOAD TABLE FrameFeatures FROM \"%s\";\n",l);
	loadFile->Write(s,strlen(s));

	while (1)
	{
		featuresAr[CHFILE]->ReadString(l);
		if (l=="")
			break;
		
		// start the features files processing
		// Color Histogram
		getFirst3Elements(l,videoId,shotId,frameId, pos);
		l = l.Mid(pos);
		sprintf(s,"%s\t%s\t%s\t[vector(\"1000\")]\"p,32,%s\"",videoId,shotId,frameId,l);
		dataFile->Write(s,strlen(s));	

		// Color Histogram HSV
		featuresAr[CHHSVFILE]->ReadString(l);
		getFirst3Elements(l,f1,f2, f3, pos);
		if (f1 != videoId || f2 != shotId || f3!=frameId)
		{
			AfxMessageBox("Error In Frame ID sequence of Color Histogram HSV");
			break;
		}
		l = l.Mid(pos);
		sprintf(s,"\t[vector(\"1000\")]\"p,256,%s\"", l);
		dataFile->Write(s,strlen(s));	

		// Color Layout
		featuresAr[CLFILE]->ReadString(l);
		getFirst3Elements(l,f1,f2,f3, pos);
		if (f1 != videoId || f2 != shotId || f3!=frameId)
		{
			AfxMessageBox("Error In Frame ID sequence of Color Layout");
			break;
		}
		l = l.Mid(pos);
		sprintf(s,"\t[vector(\"1000\")]\"p,512,%s\"",l);
		dataFile->Write(s,strlen(s));	

		// Color Moment
		featuresAr[CMFILE]->ReadString(l);
		getFirst3Elements(l,f1,f2,f3,pos);
		if (f1 != videoId || f2 != shotId || f3!=frameId)
		{
			AfxMessageBox("Error In Frame ID sequence of Color Moment");
			break;
		}
		l = l.Mid(pos);
		sprintf(s,"\t[vector(\"1000\")]\"p,2,%s\"",l);
		dataFile->Write(s,strlen(s));	

		// Texture Tamura
		featuresAr[TTFILE]->ReadString(l);
		getFirst3Elements(l,f1,f2, f3,pos);
		if (f1 != videoId || f2 != shotId || f3!=frameId)
		{
			AfxMessageBox("Error In Frame ID sequence of Texture Tamura");
			break;
		}
		l = l.Mid(pos);
		sprintf(s,"\t[vector(\"1000\")]\"p,32,%s\"",l);
		dataFile->Write(s,strlen(s));	

		// Texture Edges
		featuresAr[TEFILE]->ReadString(l);
		getFirst3Elements(l,f1,f2,f3,pos);
		if (f1 != videoId || f2 != shotId || f3!=frameId)
		{
			AfxMessageBox("Error In Frame ID sequence of Texture Edges");
			break;
		}
		l = l.Mid(pos);
		sprintf(s,"\t[vector(\"1000\")]\"p,9,%s\"",l);
		dataFile->Write(s,strlen(s));	

		// Motion Histogram
		featuresAr[MHFILE]->ReadString(l);
		getFirst3Elements(l,f1,f2,f3,pos);
		if (f1 != videoId || f2 != shotId || f3!=frameId)
		{
			AfxMessageBox("Error In Frame ID sequence of Motion Histogram");
			break;
		}
		l = l.Mid(pos);
		sprintf(s,"\t[vector(\"1000\")]\"p,9,%s\"",l);
		dataFile->Write(s,strlen(s));	

		sprintf(s,"\n");
		dataFile->Write(s,strlen(s));

		recordNo++;
		if (recordNo == fileSize)
		{
			dataFile->Close();
			delete (dataFile);

			fileNo++;
			itoa(fileNo,temp,10);

			// Get new data file for FrameFeatures
			l = outputPath + outputFileName + "F" + (const char *) temp + ".dat";
			dataFile = new CFile(l,CFile::modeWrite | CFile::modeCreate);
			l = serverPath + outputFileName + "F" + (const char *) temp + ".dat";
			sprintf(s,"LOAD TABLE FrameFeatures FROM \"%s\";\n",l);
			loadFile->Write(s,strlen(s));

			recordNo = 0;
		}
	}

	dataFile->Close();
	delete (dataFile);

	loadFile->Close();
	delete(loadFile);

	for (i=0; i <NOOFFILES; i++)
	{
		if (featuresFiles[i])
		{
			featuresAr[i]->Close();
			delete(featuresAr[i]);

			featuresFiles[i]->Close();
			delete(featuresFiles[i]);
		}
	}
}
//-------------------------------------------------------------------------

void CSQLGenDlg::createFeaturesDataFiles(CString fileName, CString outputPath, int fileSize, CString serverPath)
{
	/*open one file of load sql statements. This will contain the load for the
	Features and FeaturesMPEG tables*/

	// open the features input files
	CFile *featuresFiles[NOOFFILES], *dataFile, *loadFile;
	CArchive *featuresAr[NOOFFILES];

	int i;
	for (i=0; i<NOOFFILES;i++)
		featuresFiles[i] = 0;

	featuresFiles[CHFILE] = new CFile(fileName + "CH.txt",CFile::modeRead);
	featuresFiles[CMFILE] = new CFile(fileName + "CM.txt",CFile::modeRead);
	featuresFiles[CLFILE] = new CFile(fileName + "CL.txt",CFile::modeRead);
	featuresFiles[MHFILE] = new CFile(fileName + "MH.txt",CFile::modeRead);
	featuresFiles[TTFILE] = new CFile(fileName + "TT.txt",CFile::modeRead);
	featuresFiles[TEFILE] = new CFile(fileName + "TE.txt",CFile::modeRead);
	featuresFiles[CHHSVFILE] = new CFile(fileName + "CHHSV.txt",CFile::modeRead);

	for (i=0; i < NOOFFILES; i++)
		if (featuresFiles[i])
			featuresAr[i] = new CArchive(featuresFiles[i],CArchive::load);

	int fileNo, recordNo, pos;
	CString l, f1,f2, outputFileName, ext, videoId,shotId;
	char s[10000], temp[20];;

	fileNo = recordNo = 0;
	getFileNameParts(fileName, outputFileName,ext);
	// open the file contains the Features data and write the load command in the load file
	loadFile = new CFile(outputPath+outputFileName + "Load.sql",CFile::modeWrite | CFile::modeCreate);
	l = outputPath + outputFileName + "0.dat";
	dataFile = new CFile(l,CFile::modeWrite | CFile::modeCreate);
	l = serverPath + outputFileName + "0.dat";
	sprintf(s,"LOAD TABLE Features FROM \"%s\";\n",l);
	loadFile->Write(s,strlen(s));

	while (1)
	{
		// start the features files processing
		// Color Histogram
		featuresAr[CHFILE]->ReadString(l);
		if (l=="")
			break;
		getFirst2Elements(l,videoId,shotId, pos);
		l = l.Mid(pos);
		getStringOfXWords(l,f1,32,pos);
		f2 = l.Mid(pos);
		sprintf(s,"%s\t%s\t[vector(\"1000\")]\"p,32,%s\"\t[vector(\"1000\")]\"p,32,%s\"",videoId,shotId,f1,f2);
		dataFile->Write(s,strlen(s));	

		// Color Histogram HSV
		featuresAr[CHHSVFILE]->ReadString(l);
		getFirst2Elements(l,f1,f2, pos);
		if (f1 != videoId || f2 != shotId)
		{
			AfxMessageBox("Error In Shot ID sequence of Color Histogram HSV");
			break;
		}
		l = l.Mid(pos);
		getStringOfXWords(l,f1,256,pos);
		f2 = l.Mid(pos);
		sprintf(s,"\t[vector(\"1000\")]\"p,256,%s\"\t[vector(\"1000\")]\"p,256,%s\"", f1,f2);
		dataFile->Write(s,strlen(s));	

		// Color Layout
		featuresAr[CLFILE]->ReadString(l);
		getFirst2Elements(l,f1,f2, pos);
		if (f1 != videoId || f2 != shotId)
		{
			AfxMessageBox("Error In Shot ID sequence of Color Layout");
			break;
		}
		l = l.Mid(pos);
		getStringOfXWords(l,f1,512,pos);
		f2 = l.Mid(pos);
		sprintf(s,"\t[vector(\"1000\")]\"p,512,%s\"\t[vector(\"1000\")]\"p,512,%s\"",f1,f2);
		dataFile->Write(s,strlen(s));	

		// Color Moment
		featuresAr[CMFILE]->ReadString(l);
		getFirst2Elements(l,f1,f2, pos);
		if (f1 != videoId || f2 != shotId)
		{
			AfxMessageBox("Error In Shot ID sequence of Color Moment");
			break;
		}
		l = l.Mid(pos);
		sprintf(s,"\t[vector(\"1000\")]\"p,2,%s\"",l);
		dataFile->Write(s,strlen(s));	
	
		// Texture Tamura
		featuresAr[TTFILE]->ReadString(l);
		getFirst2Elements(l,f1,f2, pos);
		if (f1 != videoId || f2 != shotId)
		{
			AfxMessageBox("Error In Shot ID sequence of Texture Tamura");
			break;
		}
		l = l.Mid(pos);
		sprintf(s,"\t[vector(\"1000\")]\"p,32,%s\"",l);
		dataFile->Write(s,strlen(s));	

		// Texture Edges
		featuresAr[TEFILE]->ReadString(l);
		getFirst2Elements(l,f1,f2, pos);
		if (f1 != videoId || f2 != shotId)
		{
			AfxMessageBox("Error In Shot ID sequence of Texture Edges");
			break;
		}
		l = l.Mid(pos);
		getStringOfXWords(l,f1,9,pos);
		f2 = l.Mid(pos);
		sprintf(s,"\t[vector(\"1000\")]\"p,9,%s\"\t[vector(\"1000\")]\"p,9,%s\"",f1,f2);
		dataFile->Write(s,strlen(s));	

		// Motion Histogram
		featuresAr[MHFILE]->ReadString(l);
		getFirst2Elements(l,f1,f2, pos);
		if (f1 != videoId || f2 != shotId)
		{
			AfxMessageBox("Error In Shot ID sequence of Motion Histogram");
			break;
		}
		l = l.Mid(pos);
		sprintf(s,"\t[vector(\"1000\")]\"p,9,%s\"",l);
		dataFile->Write(s,strlen(s));	

		sprintf(s,"\n");
		dataFile->Write(s,strlen(s));
	
		recordNo++;
		if (recordNo == fileSize)
		{
			dataFile->Close();
			delete (dataFile);

			fileNo++;
			itoa(fileNo,temp,10);

			// Get the next data file
			l = outputPath + outputFileName + (const char *) temp + ".dat";
			CFile *dataFile = new CFile(l,CFile::modeWrite | CFile::modeCreate);
			l = serverPath + outputFileName + (const char *) temp + ".dat";
			sprintf(s,"LOAD TABLE Features FROM \"%s\";\n",l);
			loadFile->Write(s,strlen(s));

			recordNo = 0;
		}
	}

	dataFile->Close();
	delete (dataFile);

	loadFile->Close();
	delete(loadFile);

	for (i=0; i <NOOFFILES; i++)
	{
		if (featuresFiles[i])
		{
			featuresAr[i]->Close();
			delete(featuresAr[i]);

			featuresFiles[i]->Close();
			delete(featuresFiles[i]);
		}
	}
}
//-------------------------------------------------------------------------
void CSQLGenDlg::createMPEGFFeaturesDataFiles(CString fileName, CString outputPath, int fileSize, CString serverPath)
{
	/*open one file of load sql statements. Will contain the load commands for 
	the FrameFeatures and MPEGFFeatures tables */
	// open the features input files
	CFile *featuresFiles[NOOFFILES], *loadFile, *MPEGdataFile;
	CArchive *featuresAr[NOOFFILES];

	int i;
	for (i=0; i< NOOFFILES; i++)
		featuresFiles[i] = 0;

	featuresFiles[DCFILE] = new CFile(fileName + "DCF.txt",CFile::modeRead);
	featuresFiles[SCOLFILE] = new CFile(fileName + "SCOLF.txt",CFile::modeRead);
	featuresFiles[HTFILE] = new CFile(fileName + "HTF.txt",CFile::modeRead);
	featuresFiles[EHFILE] = new CFile(fileName + "EHF.txt",CFile::modeRead);

	for (i=0; i < NOOFFILES; i++)
		if (featuresFiles[i])
			featuresAr[i] = new CArchive(featuresFiles[i],CArchive::load);

	int fileNo, recordNo, pos;
	CString l, f1,f2, f3, outputFileName,ext,videoId,shotId,frameId;
	char s[10000], temp[20];;

	fileNo = recordNo = 0;
	getFileNameParts(fileName,outputFileName,ext);
	// open the file contains the MPEGFFeatures data and write the load command in the load file
	loadFile = new CFile(outputPath + outputFileName + "FLoadMPEG.sql",CFile::modeWrite | CFile::modeCreate);
	l = outputPath + outputFileName + "F0MPEG.dat";
	MPEGdataFile = new CFile(l,CFile::modeWrite | CFile::modeCreate);
	l = serverPath + outputFileName + "F0MPEG.dat";
	sprintf(s,"LOAD TABLE MPEGFFeatures FROM \"%s\";\n",l);
	loadFile->Write(s,strlen(s));

	while (1)
	{
		// Dominant Color
		featuresAr[DCFILE]->ReadString(l);
		if (l=="")
			break;

		getFirst3Elements(l,videoId,shotId,frameId,pos);
		l = l.Mid(pos);
		sprintf(s,"%s\t%s\t%s\t[vector(\"1000\")]\"p,32,%s\"",videoId,shotId,frameId,l);
		MPEGdataFile->Write(s,strlen(s));	

		// Scalable Color
		featuresAr[SCOLFILE]->ReadString(l);
		getFirst3Elements(l,f1,f2,f3,pos);
		if (f1 != videoId || f2 != shotId || f3!=frameId)
		{
			AfxMessageBox("Error In Frame ID sequence of Scalable Color");
			break;
		}
		l = l.Mid(pos);
		sprintf(s,"\t[vector(\"1000\")]\"p,32,%s\"",l);
		MPEGdataFile->Write(s,strlen(s));	

		// Homogeneous Texture
		featuresAr[HTFILE]->ReadString(l);
		getFirst3Elements(l,f1,f2,f3,pos);
		if (f1 != videoId || f2 != shotId || f3!=frameId)
		{
			AfxMessageBox("Error In Frame ID sequence of Homogeneous Texture");
			break;
		}
		l = l.Mid(pos);
		sprintf(s,"\t[vector(\"1000\")]\"p,32,%s\"",l);
		MPEGdataFile->Write(s,strlen(s));	

		// Edge Hsitogram
		featuresAr[EHFILE]->ReadString(l);
		getFirst3Elements(l,f1,f2,f3,pos);
		if (f1 != videoId || f2 != shotId || f3!=frameId)
		{
			AfxMessageBox("Error In Frame ID sequence of Edge Histogram");
			break;
		}
		l = l.Mid(pos);
		sprintf(s,"\t[vector(\"1000\")]\"p,80,%s\"",l);
		MPEGdataFile->Write(s,strlen(s));	

		sprintf(s,"\n");
		MPEGdataFile->Write(s,strlen(s));

		recordNo++;
		if (recordNo == fileSize)
		{
			MPEGdataFile->Close();
			delete (MPEGdataFile);

			fileNo++;
			itoa(fileNo,temp,10);

			// Get new data file for MPEGFFeatures
			l = outputPath + outputFileName + "F" + (const char *) temp + "MPEG.dat";
			MPEGdataFile = new CFile(l,CFile::modeWrite | CFile::modeCreate);
			l = serverPath + outputFileName + "F" + (const char *) temp + "MPEG.dat";
			sprintf(s,"LOAD TABLE MPEGFFeatures FROM \"%s\";\n",l);
			loadFile->Write(s,strlen(s));
			recordNo = 0;
		}
	}

	MPEGdataFile->Close();
	delete (MPEGdataFile);

	loadFile->Close();
	delete(loadFile);

	for (i=0; i <NOOFFILES; i++)
	{
		if (featuresFiles[i])
		{
			featuresAr[i]->Close();
			delete(featuresAr[i]);

			featuresFiles[i]->Close();
			delete(featuresFiles[i]);
		}
	}
}
//-------------------------------------------------------------------------

void CSQLGenDlg::createMPEGFeaturesDataFiles(CString fileName, CString outputPath, int fileSize, CString serverPath)
{
	/*open one file of load sql statements. This will contain the load for the
	Features and FeaturesMPEG tables*/

	// open the features input files
	CFile *featuresFiles[NOOFFILES], *MPEGdataFile, *loadFile;
	CArchive *featuresAr[NOOFFILES];

	int i;
	for (i=0; i<NOOFFILES;i++)
		featuresFiles[i] = 0;

	featuresFiles[DCFILE] = new CFile(fileName + "DC.txt",CFile::modeRead);
	featuresFiles[SCOLFILE] = new CFile(fileName + "SCOL.txt",CFile::modeRead);
	featuresFiles[HTFILE] = new CFile(fileName + "HT.txt",CFile::modeRead);
	featuresFiles[EHFILE] = new CFile(fileName + "EH.txt",CFile::modeRead);

	for (i=0; i < NOOFFILES; i++)
		if (featuresFiles[i])
			featuresAr[i] = new CArchive(featuresFiles[i],CArchive::load);

	int fileNo, recordNo, pos;
	CString l, f1,f2, outputFileName,ext, videoId,shotId;
	char s[10000], temp[20];;

	fileNo = recordNo = 0;
	getFileNameParts(fileName,outputFileName,ext);
	// open the file contains the FeaturesMPEG data and write the load command in the load file
	loadFile = new CFile(outputPath + outputFileName + "LoadMPEG.sql",CFile::modeWrite | CFile::modeCreate);
	l = outputPath + outputFileName + "0MPEG.dat";
	MPEGdataFile = new CFile(l,CFile::modeWrite | CFile::modeCreate);
	l = serverPath + outputFileName + "0MPEG.dat";
	sprintf(s,"LOAD TABLE MPEGFeatures FROM \"%s\";\n",l);
	loadFile->Write(s,strlen(s));

	while (1)
	{
		// MPEG FEATURES will be written to the FeaturesMPEG Table
		// Dominant Color
		featuresAr[DCFILE]->ReadString(l);
		if (l=="")
			break;

		getFirst2Elements(l,videoId,shotId, pos);
		l = l.Mid(pos);
		getStringOfXWords(l,f1,32,pos);
		f2 = l.Mid(pos);
		sprintf(s,"%s\t%s\t[vector(\"1000\")]\"p,32,%s\"\t[vector(\"1000\")]\"p,32,%s\"",videoId,shotId,f1,f2);
		MPEGdataFile->Write(s,strlen(s));	

		// Scalable color
		featuresAr[SCOLFILE]->ReadString(l);
		getFirst2Elements(l,f1,f2, pos);
		if (f1 != videoId || f2 != shotId)
		{
			AfxMessageBox("Error In Shot ID sequence of Scalable Color");
			break;
		}
		l = l.Mid(pos);
		sprintf(s,"\t[vector(\"1000\")]\"p,32,%s\"",l);
		MPEGdataFile->Write(s,strlen(s));	

		// Homogeneous texture
		featuresAr[HTFILE]->ReadString(l);
		getFirst2Elements(l,f1,f2, pos);
		if (f1 != videoId || f2 != shotId)
		{
			AfxMessageBox("Error In Shot ID sequence of Homogeneous Texture");
			break;
		}
		l = l.Mid(pos);
		sprintf(s,"\t[vector(\"1000\")]\"p,32,%s\"",l);
		MPEGdataFile->Write(s,strlen(s));	

		// Edge Histogram
		featuresAr[EHFILE]->ReadString(l);
		getFirst2Elements(l,f1,f2, pos);
		if (f1 != videoId || f2 != shotId)
		{
			AfxMessageBox("Error In Shot ID sequence of Edge Histogram");
			break;
		}
		l = l.Mid(pos);
		sprintf(s,"\t[vector(\"1000\")]\"p,80,%s\"",l);
		MPEGdataFile->Write(s,strlen(s));	

		sprintf(s,"\n");
		MPEGdataFile->Write(s,strlen(s));
	
		recordNo++;
		if (recordNo == fileSize)
		{
			MPEGdataFile->Close();
			delete (MPEGdataFile);

			fileNo++;
			itoa(fileNo,temp,10);

			// Get the next MPEG data file
			l = outputPath + outputFileName + (const char *) temp + "MPEG.dat";
			CFile *MPEGdataFile = new CFile(l,CFile::modeWrite | CFile::modeCreate);
			l = serverPath + outputFileName + (const char *) temp + "MPEG.dat";
			sprintf(s,"LOAD TABLE MPEGFeatures FROM \"%s\";\n",l);
			loadFile->Write(s,strlen(s));

			recordNo = 0;
		}
	}

	MPEGdataFile->Close();
	delete (MPEGdataFile);

	loadFile->Close();
	delete(loadFile);

	for (i=0; i <NOOFFILES; i++)
	{
		if (featuresFiles[i])
		{
			featuresAr[i]->Close();
			delete(featuresAr[i]);

			featuresFiles[i]->Close();
			delete(featuresFiles[i]);
		}
	}
}
//-------------------------------------------------------------------------

void CSQLGenDlg::createSQLForKeyFrames(CString fileName, CString outputPath, CString clientPath, CString serverPath)
{
	CFile *KFDatFile, *KFSqlFile;
	CArchive *KFDatAr;
	CString l, outputFileName, ext;		

	KFDatFile = new CFile(fileName + "KF.dat",CFile::modeRead);
	KFDatAr = new CArchive(KFDatFile,CArchive::load);

	getFileNameParts(fileName,outputFileName,ext);
	KFSqlFile = new CFile(outputPath + outputFileName + "KF.sql",CFile::modeWrite | CFile::modeCreate);

	while (1)
	{
		KFDatAr->ReadString(l);
		if (l=="")
			break;

		l.Replace("\t",",");
		l.Replace(clientPath, serverPath);
		l = "INSERT INTO KeyFrames Values (" + l + ");\n";
		
		KFSqlFile->Write(l,strlen(l));
	}

	KFSqlFile->Close();
	KFDatAr->Close();
	delete (KFDatAr);
	KFDatFile->Close();
	delete (KFDatFile);
}
//-------------------------------------------------------------------------

void CSQLGenDlg::createSQLForVideoShot(CString fileName, CString outputPath, CString clientPath, CString serverPath)
{
	CFile *VSDatFile, *VSSqlFile;
	CArchive *VSDatAr;
	CString l, outputFileName, ext;	
	
	VSDatFile = new CFile(fileName + "VS.dat",CFile::modeRead);
	VSDatAr = new CArchive(VSDatFile,CArchive::load);

	getFileNameParts(fileName,outputFileName,ext);
	VSSqlFile = new CFile(outputPath + outputFileName + "VS.sql",CFile::modeWrite | CFile::modeCreate);

	while (1)
	{
		VSDatAr->ReadString(l);
		if (l=="")
			break;

		l.Replace("\t",",");
		l.Replace(clientPath, serverPath);
		l = "INSERT INTO VideoShot Values (" + l + ");\n";
		
		VSSqlFile->Write(l,strlen(l));
	}

	VSSqlFile->Close();
	VSDatAr->Close();
	delete (VSDatAr);
	VSDatFile->Close();
	delete (VSDatFile);
}
//----------------------------------------------------------------
// get filename