// SQLGenDlg.h : header file
//

#if !defined(AFX_SQLGENDLG_H__E6A35FA6_E734_44EA_8B7F_115E925ECEBF__INCLUDED_)
#define AFX_SQLGENDLG_H__E6A35FA6_E734_44EA_8B7F_115E925ECEBF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CSQLGenDlg dialog

class CSQLGenDlg : public CDialog
{
// Construction
public:
	void createSQLForVideoShot(CString fileName,CString outputPath, CString clientPath, CString serverPath);
	void createSQLForKeyFrames(CString fileName,CString outputPath, CString clientPath, CString serverPath);
	void createFeaturesDataFiles(CString fileName,CString outputPath, int fileSize, CString serverPath);
	void createFrameFeaturesDataFiles(CString fileName,CString outputPath, int fileSize, CString serverPath);
	void createMPEGFeaturesDataFiles(CString fileName,CString outputPath, int fileSize, CString serverPath);
	void createMPEGFFeaturesDataFiles(CString fileName,CString outputPath, int fileSize, CString serverPath);
	CSQLGenDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CSQLGenDlg)
	enum { IDD = IDD_SQLGEN_DIALOG };
	CString	m_fileName;
	BOOL	m_frameFeatures;
	BOOL	m_shotFeatures;
	int		m_fileSize;
	CString	m_serverPath;
	BOOL	m_mpegFeatures;
	BOOL	m_otherFeatures;
	BOOL	m_insertForKeyFrames;
	BOOL	m_insertForVideoShot;
	CString	m_clientPath;
	CString	m_outputPath;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSQLGenDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CSQLGenDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SQLGENDLG_H__E6A35FA6_E734_44EA_8B7F_115E925ECEBF__INCLUDED_)
