#include "stdafx.h"
#include "stdlib.h"
#include "global.h"

void get2StringsOf1(CString s, CString &r1, CString &r2)
{
	int pos1, pos2;

	pos1=pos2=0;
	r1 = r2 = "";
	while (1)
	{
		pos2= s.Find(" ",pos1);
		if(pos2==-1) 
			break;
		r1 += s.Mid(pos1,pos2-pos1) + " ";
		pos2++;
		pos1 = s.Find(" ",pos2);
		if(pos1==-1)
			break;
		r2 += s.Mid(pos2,pos1-pos2) + " ";
		pos1++;
	}
	if(pos2==-1) 
		r1 += s.Mid(pos1);
	else r2 += s.Mid(pos2);
}


void getFirst2Elements(CString s,CString &e1, CString &e2, int &pos)
{
	// return first 2 elemnts in s and the position of the cursor after them
	int pos1,pos2;

	pos1 = s.Find(" ",0);	// position of first space
	e1 = s.Left(pos1);
	pos1++;
	pos2 = s.Find(" ",pos1);	// get position of second space
    e2 = s.Mid(pos1,pos2-pos1);
	pos1=++pos2;
	pos = pos1;
}

void getFirst3Elements(CString s,CString &e1, CString &e2, CString &e3,int &pos)
{
	// return first 2 elemnts in s and the position of the cursor after them
	int pos1,pos2;

	pos1 = s.Find(" ",0);	// position of first space
	e1 = s.Left(pos1);
	pos1++;
	pos2 = s.Find(" ",pos1);	// get position of second space
    e2 = s.Mid(pos1,pos2-pos1);
	pos2++;
	pos1 = s.Find(" ",pos2);	// get position of 3rd space
	e3 = s.Mid(pos2,pos1-pos2);
	pos2=++pos1;
	pos = pos2;
}

void getStringOfXWords(CString s, CString &e, int noOfWords, int &pos)
{
	// given the string s. return string e that contains noOfWords words 
	// (words are space separated) also return the position of the pointer
	// after getting string e

	pos = -1;
	for (int i=0;i<noOfWords; i++)
		pos = s.Find(" ",pos+1);

	e = s.Mid(0,pos);
	pos++;
}


void getFileNameParts(CString fullPath, CString &fileName, CString &ext)
{
	// given a file full path get the filename and the extension
	int pos;

	pos = fullPath.ReverseFind('\\');
	if (pos == -1)
		pos = fullPath.ReverseFind('/');

	if (pos == -1)
	{
		fileName = "";
		ext = "";
	}
	else
	{
		fileName = fullPath.Mid(pos+1);
		pos = fileName.ReverseFind('.');
		if (pos == -1)
			ext = "";
		else
		{
			ext = fileName.Mid(pos+1);
			fileName = fileName.Mid(0,pos-1);
		}
	}
}